﻿using UnityEngine;
using UnityEngine.UI;
using HarmonyLib;
using System.Collections.Generic;
using System;
using System.IO;
using System.Linq;
using UnityEngine.AzureSky;
using Steamworks;
using System.Globalization;
using HMLLibrary;
using RaftModLoader;
using System.Collections;
using System.Reflection;
using System.Reflection.Emit;
using UnityEngine.SceneManagement;
using Debug = UnityEngine.Debug;
using Object = UnityEngine.Object;
using Random = System.Random;

namespace StatisticMod
{
    public class Main : Mod
    {
        // ⁕⁜※¤ʘ●◌◈◇▷▻○◍◎◉◬⊕⊙⊗⊚
        private Harmony harmony;
        public static CanvasHelper canvas => ComponentManager<CanvasHelper>.Value;
        public static JsonModInfo modInfo;
        public static List<HealthBar> bars;
        public static List<Network_Entity> ents;
        public static List<damageIndicator> pops;
        public static TimeBar time;
        public static Compass compass;
        public static float playerHealthUpdateTime = 0;
        public static List<float> sharkTime = new List<float>();
        public const int ModUtils_Channel = 127;
        public const Messages MessageId = (Messages)5004;
        public const int healthCall = 0;
        public static List<HUDEquipmentDisplay> equipDisplay;
        public static bool updatePlayerHealth
        {
            get
            {
                playerHealthUpdateTime += Time.deltaTime;
                if (playerHealthUpdateTime > 1)
                {
                    playerHealthUpdateTime--;
                    return true;
                }
                return false;
            }
        }
        public static float aspectRatio
        {
            get
            {
                return (float)Screen.width / Screen.height;
            }
        }
        public static GameObject dmgDisplay
        {
            set
            {
                dmgObject = value;
                dmgOffset = dmgObject.GetComponent<RectTransform>();
                dmgStart = dmgOffset.anchoredPosition;
                dmgText = dmgObject.GetComponent<Text>();
            }
            get
            {
                return dmgObject;
            }
        }
        public static RectTransform dmgOffset;
        public static Vector2 dmgStart;
        public static Text dmgText;
        private static GameObject dmgObject;
        public static Text statHeT;
        public static Text statHuT;
        public static Text statThT;
        public static sharkIndicator sharkI;
        public static centerPointer raftCenter;
        public static float dmgTime = 0f;
        static List<int> storyNotes = new int[] { 901, 2, 17, 902, 43, 53, 60, 68 }.ToList();
        static List<string> objectiveNames = new string[] { "Build Reciever", "Radio Tower", "Cruise Ship", "Balboa Island", "Caravan Town", "Tangaroa", "Varuna Point", "Temperance", "Utopia" }.ToList();
        static Dictionary<string, StatManager> boolSettings = new Dictionary<string, StatManager>
    {
        { "weather", new StatManager ("Weather is ", setWeatherVisible) },
        { "weathertimer", new StatManager ("Weather timer is ", setWeatherTimer) },
        { "sharktimer", new StatManager ("Shark respawn timer is ", setSharkTimer) },
        { "fullhealth", new StatManager ("Full health bars are ", setFullBars) },
        { "objective", new StatManager ("Story objective is ", setShowObjective) },
        { "uses", new StatManager ("Remaining item uses are ", setShowUses) },
        { "equipment", new StatManager ("Equipment is ", setHUDEquip) },
        { "weight", new StatManager ("Raft foundation count is ", setShowWeight) },
        { "speed", new StatManager ("Speed display is ", setShowSpeed) },
        { "itemids", new StatManager ("Item IDs are ", setShowIds) },
        { "raftcenter", new StatManager ("Raft's center is ", setShowCenter) },
        { "compass", new StatManager ("Compass is ", setShowCompass) }
    };
        public static bool timeIsClock
        {
            get
            {
                int s = clockSetting;
                if (s == 3)
                {
                    Raft raft = ComponentManager<Raft>.Value;
                    if (raft != null)
                    {
                        Clock clock = raft.GetComponentInChildren<Clock>();
                        return clock != null;
                    }
                }
                return s == 2;
            }
        }
        public static int clockSetting = 1;
        public static bool showFullBars = true;
        public static int statSetting = 2;
        public static bool showWeather = true;
        public static bool showWeatherTimer = false;
        public static bool showSharkRespawn = true;
        public static bool showHUDEquipment = true;
        public static bool showStoryObjective = true;
        public static bool showDurability = true;
        public static bool showFoundations = true;
        public static bool showCenter = false;
        public static bool showCompass = true;
        public static bool showSpeed = true;
        public static float barDrawDistance = 10;
        public static float HUDPositionX = 50;
        public static float HUDPositionY = 50;
        public static bool showItemIds = false;

        public static List<string> exclusions = new List<string>();
        public void Start()
        {
            modInfo = modlistEntry.jsonmodinfo;
            (harmony = new Harmony("com.aidanamite.StatisticMod")).PatchAll();
            equipDisplay = new List<HUDEquipmentDisplay>();
            bars = new List<HealthBar>();
            ents = new List<Network_Entity>();
            pops = new List<damageIndicator>();
            Network_Player player = RAPI.GetLocalPlayer();
            if (player != null)
            {
                Patch_CanvasHelper.Start(canvas);
                foreach (Slot_Equip slot in player.Inventory.equipSlots)
                    if (slot.HasValidItemInstance())
                        Patch_PlayerEquipment.Equip(player.PlayerEquipment, slot.itemInstance, slot);
                foreach (Inventory inv in FindObjectsOfType<Inventory>())
                    if (Traverse.Create(inv).Field("canvas").GetValue<CanvasHelper>() != null)
                        Patch_Inventory.Start(inv);
                foreach (Network_Entity entity in FindObjectsOfType<Network_Entity>())
                    if (entity.Network != null)
                        Patch_NetworkEntity.Start(entity);
            }
            Log("Mod has been loaded!");
        }

        bool ModUtils_MessageRecieved(CSteamID steamID, NetworkChannel channel, Message message)
        {
            object[] values;
            if (message.Type == MessageId && (values = ModUtils_GetGenericMessageValues(message, false)) != null)
                switch (ModUtils_GetGenericMessageId(message))
                {
                    case healthCall:
                        Network_Player remotePlayer = ComponentManager<Raft_Network>.Value.GetPlayerFromID(steamID);
                        foreach (Network_Entity ent in ents)
                            if (ent.ObjectIndex == remotePlayer.ObjectIndex)
                            {
                                ent.stat_health.Value = (float)values[0];
                                break;
                            }
                        return true;
                    default:
                        break;
                }
            return false;
        }
        public static object[] ModUtils_GetGenericMessageValues(Message message, bool logErrors) => null;
        public static int ModUtils_GetGenericMessageId(Message message) => 0;
        public static Message ModUtils_CreateGenericMessage(Messages type, int subType, params object[] values) => null;

        public void OnModUnload()
        {
            harmony?.UnpatchAll(harmony.Id);
            Destroy(Patch_CanvasHelper.HUD?.gameObject);
            sharkI?.Destroy();
            raftCenter?.Destroy();
            Destroy(statHeT?.gameObject);
            Destroy(statThT?.gameObject);
            Destroy(statHuT?.gameObject);
            Destroy(dmgObject?.gameObject);
            while (bars?.Count > 0)
            {
                bars[0]?.Destroy();
                bars.RemoveAt(0);
                ents.RemoveAt(0);
            }
            foreach (Inventory inv in FindObjectsOfType<Inventory>())
                Destroy(inv.transform.GetComponent<duraText>());
            WorldEvent_WorldUnloaded();
            Log("Mod has been unloaded!");
        }

        public override void WorldEvent_WorldUnloaded()
        {
            while (equipDisplay.Count > 0)
            {
                equipDisplay[0].Destroy();
                equipDisplay.RemoveAt(0);
            }
            while (pops.Count > 0)
            {
                pops[0].Destroy();
                pops.RemoveAt(0);
            }
        }

        //public static void Log(object message)
        //{
        //Debug.Log("[" + modInfo.name + "]: " + message.ToString());
        //}


        public static void ErrorLog(object message)
        {
            Debug.LogError("[" + modInfo.name + "]: " + message.ToString());
        }

        public static void showCrosshairText(string text)
        {
            canvas.displayTextManager.ShowText(text);
        }

        public static GameObject CreateText(Transform canvas_transform, float x, float y, string text_to_print, int font_size, Color text_color, float width, float height, Font font, string name = "Text")
        {
            GameObject UItextGO = new GameObject("Text");
            UItextGO.transform.SetParent(canvas_transform, false);
            RectTransform trans = UItextGO.AddComponent<RectTransform>();
            trans.sizeDelta = new Vector2(width, height);
            trans.anchoredPosition = new Vector2(x, y);
            Text text = UItextGO.AddComponent<Text>();
            text.text = text_to_print;
            text.font = font;
            text.fontSize = font_size;
            text.color = text_color;
            text.name = name;
            Shadow shadow = UItextGO.AddComponent<Shadow>();
            shadow.effectColor = new Color();
            return UItextGO;
        }
        public static void AddTextShadow(GameObject textObject, Color shadowColor, Vector2 shadowOffset)
        {
            Shadow shadow = textObject.AddComponent<Shadow>();
            shadow.effectColor = shadowColor;
            shadow.effectDistance = shadowOffset;
        }
        public static void CopyTextShadow(GameObject textObject, GameObject shadowSource)
        {
            Shadow sourcesShadow = shadowSource.GetComponent<Shadow>();
            if (sourcesShadow == null)
                sourcesShadow = shadowSource.GetComponentInChildren<Shadow>();
            AddTextShadow(textObject, sourcesShadow.effectColor, sourcesShadow.effectDistance);
        }
        public static GameObject CreateLine(Canvas canvas, float length, float width, float x, float y, Color lineColor, float angle)
        {
            GameObject lineContainer = new GameObject();
            lineContainer.transform.SetParent(canvas.transform, false);
            RectTransform trans = lineContainer.AddComponent<RectTransform>();
            trans.sizeDelta = canvas.pixelRect.size;
            trans.anchoredPosition = new Vector2(0, 0);
            UILine.setCreationValues(new Vector2(x, y), length, width, angle);
            UILine lineObj = lineContainer.AddComponent<UILine>();
            lineObj.color = lineColor;
            return lineContainer;
        }

        [ConsoleCommand(name: "setClock", docs: "Syntax: 'setClock <none|bar|clock|auto>'  Changes the display type of the clock")]
        public static string MyCommand(string[] args)
        {
            if (args.Length < 1)
                return "Not enough arguments";
            if (args.Length > 1)
                return "Too many arguments";
            args[0] = args[0].ToLower();
            int ind = new string[] { "none", "bar", "clock", "auto" }.ToList().IndexOf(args[0]);
            if (ind >= 0)
            {
                clockSetting = ind;
                ResaveValues();
                if (ind == 3)
                    return "Time display is now automatic";
                return "Time display is now " + (ind > 0 ? "a " : "") + ToTitle(args[0]);
            }
            return args[0] + " is not valid";
        }

        [ConsoleCommand(name: "setStatNumbers", docs: "Syntax: 'setStatNumbers <none|round|decimal>'  Changes the display type of the stat numbers")]
        public static string MyCommand10(string[] args)
        {
            if (args.Length < 1)
                return "Not enough arguments";
            if (args.Length > 1)
                return "Too many arguments";
            args[0] = args[0].ToLower();
            int ind = new string[] { "none", "round", "decimal" }.ToList().IndexOf(args[0]);
            if (ind >= 0)
            {
                if (statSetting == ind)
                    return "Setting is unchanged";
                statSetting = ind;
                ResaveValues();
                if (ind == 0)
                    return "Stat numbers are no longer shown";
                return "Stat numbers are now set to " + (ind == 2 ? "un" : "") + "rounded";
            }
            return args[0] + " is not valid";
        }

        [ConsoleCommand(name: "showHealth", docs: "Syntax: 'showHealth <animal>'  Enables floating health bars for the specified mob")]
        public static string MyCommand2(string[] args)
        {
            if (args.Length < 1)
                return "Not enough arguments";
            if (args.Length > 1)
                return "Too many arguments";
            args[0] = args[0].ToLower();
            if (removeExclusion(args[0]))
                return ToTitle(args[0]) + " are now showing health bars";
            return ToTitle(args[0]) + " are already showing health bars";
        }

        [ConsoleCommand(name: "hideHealth", docs: "Syntax: 'hideHealth <animal>'  Disables floating health bars for the specified mob")]
        public static string MyCommand3(string[] args)
        {
            if (args.Length < 1)
                return "Not enough arguments";
            if (args.Length > 1)
                return "Too many arguments";
            args[0] = args[0].ToLower();
            if (addExclusion(args[0]))
                return ToTitle(args[0]) + " are no longer showing health bars";
            return ToTitle(args[0]) + " already don't show health bars";
        }

        [ConsoleCommand(name: "show", docs: "Syntax: 'show <GUI Aspect>'  Enables a part of the Statistic Mod GUI elements")]
        public static string MyCommand4(string[] args)
        {
            if (args.Length < 1)
                return "Not enough arguments";
            if (args.Length > 1)
                return "Too many arguments";
            args[0] = args[0].ToLower();
            if (!boolSettings.ContainsKey(args[0]))
                return args[0] + " is not a valid GUI aspect name";
            return boolSettings[args[0]].Set(true);
        }

        [ConsoleCommand(name: "hide", docs: "Syntax: 'hide <GUI Aspect>'  Disables a part of the Statistic Mod GUI elements")]
        public static string MyCommand5(string[] args)
        {
            if (args.Length < 1)
                return "Not enough arguments";
            if (args.Length > 1)
                return "Too many arguments";
            args[0] = args[0].ToLower();
            if (!boolSettings.ContainsKey(args[0]))
                return args[0] + " is not a valid GUI aspect name";
            return boolSettings[args[0]].Set(false);
        }

        [ConsoleCommand(name: "guiAspects", docs: "Lists the names of the Statistic Mod GUI elements that can be toggled with 'show' and 'hide'")]
        public static string MyCommand6(string[] args)
        {
            string str = "";
            foreach (string name in boolSettings.Keys)
                if (str == "")
                    str = name;
                else
                    str += "\n" + name;
            return str;
        }

        [ConsoleCommand(name: "healthDrawDistance", docs: "Syntax: 'healthDrawDistance <distance>'  Changes how far away health bars can be seen from")]
        public static string MyCommand7(string[] args)
        {
            if (args.Length < 1)
                return "Not enough arguments";
            if (args.Length > 1)
                return "Too many arguments";
            try
            {
                barDrawDistance = float.Parse(args[0]);
                ResaveValues();
                return "Can now see health bars from " + args[0];
            }
            catch
            {
                return "Cannot parse " + args[0] + " as a number";
            }
        }

        [ConsoleCommand(name: "setHUDPosition", docs: "Syntax: 'setHUDPosition <\u200bx> <\u200by>'  Changes the location, of the extra HUD information, on the screen")]
        public static string MyCommand8(string[] args)
        {
            if (args.Length < 2)
                return "Not enough arguments";
            if (args.Length > 2)
                return "Too many arguments";
            try
            {
                float tmp = float.Parse(args[1]);
                HUDPositionX = float.Parse(args[0]);
                HUDPositionY = tmp;
                ResaveValues();
                return "HUD has been moved";
            }
            catch
            {
                return "Failed to parse either " + args[0] + " or " + args[1] + " as a number";
            }
        }

        [ConsoleCommand(name: "setHUDToMouse", docs: "Sets the location, of the extra HUD information, on the screen to the location of the mouse")]
        public static string MyCommand9(string[] args)
        {
            HUDPositionX = Input.mousePosition.x / aspectRatio;
            HUDPositionY = canvas.GetComponent<RectTransform>().sizeDelta.y - Input.mousePosition.y;
            ResaveValues();
            return "HUD has been moved";
        }

        private static string ToTitle(string str)
        {
            if (str.Length == 0)
                return "";
            if (str.Length == 1)
                return str.ToUpper();
            return str.Substring(0, 1).ToUpper() + str.Substring(1).ToLower();
        }

        public static void SetDamage(float amount)
        {
            dmgText.text = (-amount).ToString();
            dmgText.color = amount < 0 ? Color.green : Color.red;
            dmgTime = 0;
            dmgObject.SetActiveSafe(true);
        }

        public static bool hasExclusion(string name) => exclusions.Contains(name);

        private static bool addExclusion(string name)
        {
            if (exclusions.AddUniqueOnly(name))
            {
                ExtraSettingsAPI_SetDataValue("exclusions", name, "");
                return true;
            }
            return false;
        }

        private static bool removeExclusion(string name)
        {
            if (exclusions.Remove(name))
            {
                ResaveValues();
                return true;
            }
            return false;
        }

        private static bool setFullBars(bool visible)
        {
            if (showFullBars == visible)
                return false;
            showFullBars = visible;
            ResaveValues();
            return true;
        }

        private static bool setWeatherVisible(bool visible)
        {
            if (showWeather == visible)
                return false;
            showWeather = visible;
            ResaveValues();
            return true;
        }

        private static bool setWeatherTimer(bool visible)
        {
            if (showWeatherTimer == visible)
                return false;
            showWeatherTimer = visible;
            ResaveValues();
            return true;
        }

        private static bool setSharkTimer(bool visible)
        {
            if (showSharkRespawn == visible)
                return false;
            showSharkRespawn = visible;
            ResaveValues();
            return true;
        }

        private static bool setShowObjective(bool visible)
        {
            if (showStoryObjective == visible)
                return false;
            showStoryObjective = visible;
            ResaveValues();
            return true;
        }

        private static bool setShowUses(bool visible)
        {
            if (showDurability == visible)
                return false;
            showDurability = visible;
            ResaveValues();
            return true;
        }

        private static bool setHUDEquip(bool visible)
        {
            if (showHUDEquipment == visible)
                return false;
            showHUDEquipment = visible;
            ResaveValues();
            return true;
        }

        private static bool setShowWeight(bool visible)
        {
            if (showFoundations == visible)
                return false;
            showFoundations = visible;
            ResaveValues();
            return true;
        }

        private static bool setShowSpeed(bool visible)
        {
            if (showSpeed == visible)
                return false;
            showSpeed = visible;
            ResaveValues();
            return true;
        }

        private static bool setShowIds(bool visible)
        {
            if (showItemIds == visible)
                return false;
            showItemIds = visible;
            ResaveValues();
            return true;
        }

        private static bool setShowCenter(bool visible)
        {
            if (showCenter == visible)
                return false;
            showCenter = visible;
            ResaveValues();
            return true;
        }

        private static bool setShowCompass(bool visible)
        {
            if (showCompass == visible)
                return false;
            showCompass = visible;
            ResaveValues();
            return true;
        }

        public static string getNextStoryLocation()
        {
            if (RAPI.GetLocalPlayer() == null)
                return "Player not found";
            int ind = -1;
            NoteBookUI book = RAPI.GetLocalPlayer().NoteBookUI;
            foreach (NoteBookNote note in book.GetAllNotes())
            {
                if (note.isUnlocked)
                    ind = Math.Max(storyNotes.IndexOf(note.noteIndex), ind);
            }
            return objectiveNames[ind + 1];
        }

        public static void ResaveValues()
        {
            ExtraSettingsAPI_SetComboboxSelectedIndex("Clock Mode", clockSetting);
            ExtraSettingsAPI_SetComboboxSelectedIndex("Stat Numbers", statSetting);
            ExtraSettingsAPI_SetCheckboxState("Weather Display", showWeather);
            ExtraSettingsAPI_SetCheckboxState("Weather Timer", showWeatherTimer);
            ExtraSettingsAPI_SetCheckboxState("Shark Respawn Timer", showSharkRespawn);
            ExtraSettingsAPI_SetCheckboxState("Full Health Bars", showFullBars);
            ExtraSettingsAPI_SetCheckboxState("Story Objective", showStoryObjective);
            ExtraSettingsAPI_SetCheckboxState("Item Durability", showDurability);
            ExtraSettingsAPI_SetCheckboxState("Equipment Display", showHUDEquipment);
            ExtraSettingsAPI_SetCheckboxState("Raft Weight", showFoundations);
            ExtraSettingsAPI_SetCheckboxState("Compass", showCompass);
            ExtraSettingsAPI_SetCheckboxState("Speed Display", showSpeed);
            ExtraSettingsAPI_SetCheckboxState("Item IDs", showItemIds);
            ExtraSettingsAPI_SetCheckboxState("Raft Center", showCenter);
            ExtraSettingsAPI_SetSliderValue("Health Bar Max Draw Distance", barDrawDistance);
            ExtraSettingsAPI_SetSliderValue("HUD X Offset", HUDPositionX / 1200);
            ExtraSettingsAPI_SetSliderValue("HUD Y Offset", HUDPositionY / 1200);
            ExtraSettingsAPI_SetDataValues("exclusions", exclusions.ToDictionary(x => ""));
        }

        public void ExtraSettingsAPI_Load() => ExtraSettingsAPI_SettingsClose();

        public void ExtraSettingsAPI_SettingsClose()
        {
            clockSetting = ExtraSettingsAPI_GetComboboxSelectedIndex("Clock Mode");
            statSetting = ExtraSettingsAPI_GetComboboxSelectedIndex("Stat Numbers");
            showWeather = ExtraSettingsAPI_GetCheckboxState("Weather Display");
            showWeatherTimer = ExtraSettingsAPI_GetCheckboxState("Weather Timer");
            showSharkRespawn = ExtraSettingsAPI_GetCheckboxState("Shark Respawn Timer");
            showFullBars = ExtraSettingsAPI_GetCheckboxState("Full Health Bars");
            showStoryObjective = ExtraSettingsAPI_GetCheckboxState("Story Objective");
            showDurability = ExtraSettingsAPI_GetCheckboxState("Item Durability");
            showHUDEquipment = ExtraSettingsAPI_GetCheckboxState("Equipment Display");
            showFoundations = ExtraSettingsAPI_GetCheckboxState("Raft Weight");
            showSpeed = ExtraSettingsAPI_GetCheckboxState("Speed Display");
            showItemIds = ExtraSettingsAPI_GetCheckboxState("Item IDs");
            showCenter = ExtraSettingsAPI_GetCheckboxState("Raft Center");
            showCompass = ExtraSettingsAPI_GetCheckboxState("Compass");
            barDrawDistance = ExtraSettingsAPI_GetSliderValue("Health Bar Max Draw Distance");
            HUDPositionX = 1200 * ExtraSettingsAPI_GetSliderRealValue("HUD X Offset");
            HUDPositionY = 1200 * ExtraSettingsAPI_GetSliderRealValue("HUD Y Offset");
            exclusions = ExtraSettingsAPI_GetDataNames("exclusions").ToList();
        }


        public static int ExtraSettingsAPI_GetComboboxSelectedIndex(string SettingName) => -1;
        public static string ExtraSettingsAPI_GetComboboxSelectedItem(string SettingName) => "";
        public static bool ExtraSettingsAPI_GetCheckboxState(string SettingName) => false;
        public static float ExtraSettingsAPI_GetSliderValue(string SettingName) => 0;
        public static float ExtraSettingsAPI_GetSliderRealValue(string SettingName) => 0;
        public static void ExtraSettingsAPI_SetComboboxSelectedIndex(string SettingName, int value) { }
        public static void ExtraSettingsAPI_SetComboboxSelectedItem(string SettingName, string value) { }
        public static void ExtraSettingsAPI_SetCheckboxState(string SettingName, bool value) { }
        public static void ExtraSettingsAPI_SetSliderValue(string SettingName, float value) { }
        public static string[] ExtraSettingsAPI_GetDataNames(string settingName) => new string[0];
        public static void ExtraSettingsAPI_SetDataValue(string settingName, string subname, string value) { }
        public static void ExtraSettingsAPI_SetDataValues(string settingName, Dictionary<string, string> values) { }
    }

    public static class ExtentionMethods
    {
        public static Text GetText(this Transform canvas, string name)
        {
            foreach (Text gO in canvas.GetComponentsInChildren<Text>())
            {
                if (gO.name == name)
                    return gO;
            }
            return null;
        }

        public static string GetFoodValues(this Item_Base item) => (item.settings_consumeable.HungerYield != 0 ? "\nFood: " + item.settings_consumeable.HungerYield.ToString() : "")
                    + (item.settings_consumeable.BonusHungerYield != 0 ? "\nFood Bonus: " + item.settings_consumeable.BonusHungerYield.ToString() : "")
                    + (item.settings_consumeable.ThirstYield != 0 ? "\nWater: " + item.settings_consumeable.ThirstYield.ToString() : "")
                    + (item.settings_consumeable.BonusThirstYield != 0 ? "\nWater Bonus: " + item.settings_consumeable.BonusThirstYield.ToString() : "");
    }

    [HarmonyPatch(typeof(Battery), "OnIsRayed")]
    public class Patch_BatteryRayed
    {
        public static Battery batteryInstance;
        static void Prefix(Battery __instance)
        {
            batteryInstance = __instance;
        }
        static void Postfix()
        {
            batteryInstance = null;
        }
    }

    [HarmonyPatch(typeof(DisplayTextManager), "ShowText", new Type[] { typeof(string), typeof(KeyCode), typeof(int), typeof(int), typeof(bool) })]
    public class Patch_BatteryDisplayText
    {
        static void Prefix(ref string text)
        {
            if (Patch_BatteryRayed.batteryInstance != null)
                text += "\n" + Mathf.CeilToInt(Patch_BatteryRayed.batteryInstance.NormalizedBatteryLeft * 100) + "%";
        }
    }

    [HarmonyPatch(typeof(Pickup), "Update")]
    public class Patch_LookingUpdate
    {
        static bool shown = false;
        static void Postfix(Pickup __instance)
        {
            if (Helper.HitAtCursor(out var raycastHit, Player.UseDistance, LayerMasks.MASK_Item) || Helper.HitAtCursor(out raycastHit, Player.UseDistance, LayerMasks.MASK_RaycastInteractable))
            {
                Plant crop = raycastHit.transform.GetComponentInParent<Plant>();
                if (crop)
                {
                    showPlantProgress(crop);
                    return;
                }
            }
            if (shown)
            {
                Main.canvas.displayTextManager.HideDisplayTexts();
                shown = false;
            }
        }

        static void showPlantProgress(Plant target)
        {
            if (target.FullyGrown())
            {
                if (target.GetComponent<HarvestableTree>())
                {
                    var left = Mathf.FloorToInt(target.pickupComponent.yieldHandler.Yield.Count / target.pickupComponent.yieldHandler.yieldAsset.yieldAssets.Count * 100);
                    if (left < 100)
                    {
                        shown = true;
                        Main.showCrosshairText(left + "%");
                    }
                }
                return;
            }
            var growTime = Mathf.FloorToInt(target.GetGrowTimer() / Traverse.Create(target).Field("growTimeSec").GetValue<float>() * 100);
            if (growTime < 100)
            {
                shown = true;
                Main.showCrosshairText(growTime + "%");
            }
        }
    }

    [HarmonyPatch(typeof(CanvasHelper), "Start")]
    static class Patch_CanvasHelper
    {
        public static Text HUD;
        [HarmonyPatch("Start")]
        [HarmonyPostfix]
        public static void Start(CanvasHelper __instance)
        {
            GameObject display = Main.CreateText(__instance.transform, -500 * Main.aspectRatio, 350, "\nIf you can see this something has gone wrong", __instance.dropText.fontSize, __instance.dropText.color, 400, 300, __instance.dropText.font, "aTimeDisplay");
            Main.CopyTextShadow(display, __instance.dropText.gameObject);
            Main.time = new TimeBar(display, __instance.dropText.font.lineHeight, 50, 25);
            Main.compass = new Compass(display, __instance.dropText.font.lineHeight, 400, 150);
            display.transform.SetAsFirstSibling();
            HUD = display.GetComponent<Text>();
            Main.dmgDisplay = Main.CreateText(__instance.transform, 130, 0, "0", __instance.dropText.fontSize, Color.red, 200, __instance.dropText.fontSize * 1.5f, __instance.dropText.font, "aDmgDisplay");
            Main.CopyTextShadow(Main.dmgDisplay, __instance.dropText.gameObject);
            Main.dmgDisplay.transform.SetAsFirstSibling();
            Main.dmgDisplay.SetActiveSafe(false);
            RectTransform Box = __instance.healthSlider.GetComponent<RectTransform>();
            GameObject stat = Main.CreateText(__instance.healthSlider.transform, 0, 0, "??/??", __instance.dropText.fontSize, __instance.dropText.color, 175, 50, __instance.dropText.font, "aStatDisplay");
            Main.AddTextShadow(stat, Color.black, new Vector2(2, -2));
            Main.statHeT = stat.GetComponent<Text>();
            Box = __instance.hungerSlider.GetComponent<RectTransform>();
            stat = Main.CreateText(__instance.hungerSlider.transform, 0, 0, "??/??", __instance.dropText.fontSize, new Color(0, 0.5f, 0), 175, 50, __instance.dropText.font, "aStatDisplay");
            Main.AddTextShadow(stat, Color.black, new Vector2(2, -2));
            Main.statHuT = stat.GetComponent<Text>();
            Box = __instance.thirstSlider.GetComponent<RectTransform>();
            stat = Main.CreateText(__instance.thirstSlider.transform, 0, 0, "??/??", __instance.dropText.fontSize, new Color(0.2f, 0.5f, 0.9f), 175, 50, __instance.dropText.font, "aStatDisplay");
            Main.AddTextShadow(stat, Color.black, new Vector2(2, -2));
            Main.statThT = stat.GetComponent<Text>();
            Main.sharkI = new sharkIndicator();
            Main.sharkTime = new List<float>();
            Main.raftCenter = new centerPointer();
        }

        static Vector3 lastPos = Vector3.zero;
        static int steps = 0;
        static float speed = 0;
        static float time;
        [HarmonyPatch("Update")]
        [HarmonyPostfix]
        static void Update(CanvasHelper __instance)
        {
            float timePassed = Time.deltaTime;
            Network_Player player = RAPI.GetLocalPlayer();
            try
            {
                if (player)
                {
                    if (timePassed != 0)
                    {
                        steps++;
                        time += timePassed;
                        if (steps == 20)
                        {
                            speed = (lastPos - player.transform.position).magnitude / time;
                            lastPos = player.transform.position;
                            steps = 0;
                            time = 0;
                        }
                    }
                }
                WeatherManager wm = ComponentManager<WeatherManager>.Value;
                AzureSkyController sc = ComponentManager<AzureSkyController>.Value;
                for (var i = Main.sharkTime.Count - 1; i >= 0; i--)
                    if ((Main.sharkTime[i] -= timePassed) <= 0)
                        Main.sharkTime.RemoveAt(i);
                if (HUD != null && wm != null && sc != null && wm.GetCurrentWeather() != null)
                {
                    Vector2 screenSize = __instance.GetComponent<RectTransform>().sizeDelta;
                    Main.time.Update(sc.timeOfDay.hour);
                    Main.compass.Update();
                    HUD.rectTransform.localPosition = new Vector2(Main.HUDPositionX * Main.aspectRatio + 200 - screenSize.x / 2, screenSize.y / 2 - Main.HUDPositionY - 150);
                    HUD.text = (Main.clockSetting == 0 ? "" : $"Time: {(Main.timeIsClock ? GetTimeString(sc.timeOfDay.hour) : "")}\n")
                        + (Main.showWeather ? $"Weather: {GetWeatherString(wm.GetCurrentWeather().so_weather.uniqueWeatherType)}\n" : "")
                        + (Main.showWeatherTimer ? $"Weather Time: {GetTimeString(wm.WeatherTimer / 60, false)}\n" : "")
                        + (Main.showSpeed ? $"Current Speed: {speed.ToString("N1")} m/s\n" : "")
                        + (Main.showFoundations ? $"Foundation Count: {ComponentManager<RaftBounds>.Value?.FoundationCount} (Needs {Math.Ceiling(RaftWeightManager.FoundationWeight / 100f)} Engine{(RaftWeightManager.FoundationWeight / 100 == 0 ? "" : "s")})\n" : "")
                        + ((Main.sharkTime.Count > 0 && Main.showSharkRespawn) ? $"Shark respawning in: [{Main.sharkTime.Join(x => GetTimeString(x / 60, false))}]\n" : "")
                        + (Main.showStoryObjective ? $"\nNext Story Location: {Main.getNextStoryLocation()}" : "");
                }
            }
            catch (Exception e)
            {
                Debug.LogError("HUD Update Failed: " + e);
            }
            try
            {
                foreach (HealthBar bar in Main.bars)
                    bar.UpdateFacing();
            }
            catch (Exception e)
            {
                Debug.LogError("Health Bar Updates Failed: " + e);
            }
            try
            {
                for (int i = Main.pops.Count - 1; i >= 0; i--)
                    Main.pops[i].Update();
            }
            catch (Exception e)
            {
                Debug.LogError("Damage Indicator Updates Failed: " + e);
            }
            try
            {
                Main.dmgTime += timePassed;
                if (Main.dmgDisplay.activeSelf)
                {
                    Main.dmgOffset.anchoredPosition = Main.dmgStart + new Vector2(Main.dmgTime, 0) * 100;
                    Main.dmgText.color = new Color(Main.dmgText.color.r, Main.dmgText.color.g, Main.dmgText.color.b, 1 - Main.dmgTime);
                    if (Main.dmgText.color.a <= 0)
                        Main.dmgDisplay.SetActiveSafe(false);
                }
            }
            catch (Exception e)
            {
                Debug.LogError("HUD Damage Indicator Update Failed: " + e);
            }
            try
            {
                if (player != null)
                {
                    for (int i = 0; i < Main.equipDisplay.Count; i++)
                        Main.equipDisplay[i].Update(i);
                    PlayerStats Stats = player.Stats;
                    Main.statHeT.text = Main.statSetting == 0 ? "" : (StatValue(Stats.stat_health.Value) + "/" + StatValue(Stats.stat_health.Max));
                    Main.statHuT.text = Main.statSetting == 0 ? "" : (StatValue(Stats.stat_hunger.Normal.Value) + "/" + StatValue(Stats.stat_hunger.Normal.Max) + (Stats.stat_hunger.Bonus.Value > 0 ? " + " + StatValue(Stats.stat_hunger.Bonus.Value) : ""));
                    Main.statThT.text = Main.statSetting == 0 ? "" : (StatValue(Stats.stat_thirst.Normal.Value) + "/" + StatValue(Stats.stat_thirst.Normal.Max) + (Stats.stat_thirst.Bonus.Value > 0 ? " + " + StatValue(Stats.stat_thirst.Bonus.Value) : ""));
                    if (Main.updatePlayerHealth)
                    {
                        var msg = Main.ModUtils_CreateGenericMessage(Main.MessageId, Main.healthCall, Stats.stat_health.Value);
                        if (msg == null)
                            Debug.LogWarning($"[{Main.modInfo.name}]: Could not send health data to connected clients, you're probably missing the ModUtils mod");
                        else
                            foreach (KeyValuePair<CSteamID, Network_Player> pair in player.Network.remoteUsers.ToArray())
                                if (!pair.Value.IsLocalPlayer)
                                    RAPI.SendNetworkMessage(msg, Main.ModUtils_Channel);
                    }
                }
            }
            catch (Exception e)
            {
                Debug.LogError("Stat Overlay Update Failed: " + e);
            }
            try
            {
                Main.sharkI?.Update();
            }
            catch (Exception e)
            {
                Debug.LogError("Shark Indicator Update Failed: " + e);
            }
            try
            {
                Main.raftCenter?.Update();
            }
            catch (Exception e)
            {
                Debug.LogError("Raft Center Indicator Update Failed: " + e);
            }
        }

        static string StatValue(float value) => Math.Round(value, Main.statSetting == 1 ? 0 : 1).ToString();

        static string GetTimeString(float TimeOfDay, bool addZero = true)
        {
            int hour = (int)TimeOfDay;
            int minute = (int)((TimeOfDay - hour) * 60);
            if (addZero)
                return hour.ToString().PadLeft(2, '0') + ":" + minute.ToString().PadLeft(2, '0');
            return hour.ToString() + ":" + minute.ToString().PadLeft(2, '0');
        }



        static string GetWeatherString(UniqueWeatherType type)
        {
            if (type == UniqueWeatherType.Default)
            {
                return "Normal";
            }
            else
                return type.ToString();
        }
    }

    [HarmonyPatch(typeof(PlayerEquipment))]
    static class Patch_PlayerEquipment
    {
        [HarmonyPatch("Equip")]
        [HarmonyPostfix]
        public static void Equip(PlayerEquipment __instance, ItemInstance item, Slot_Equip slot)
        {
            Network_Player player = Traverse.Create(__instance).Field("playerNetwork").GetValue<Network_Player>();
            int ind = player.Inventory.equipSlots.IndexOf(slot);
            if (item.BaseItemMaxUses > 1)
            {
                HUDEquipmentDisplay newDisplay = new HUDEquipmentDisplay(Main.canvas, player.Inventory.equipSlots[ind], player.Inventory.slotPrefab, new Vector2(10, 200), ind, player.Inventory.gridLayoutGroup.cellSize);
                for (int i = 0; i < Main.equipDisplay.Count; i++)
                    if (Main.equipDisplay[i].slotIndex < ind)
                    {
                        Main.equipDisplay.Insert(i, newDisplay);
                        return;
                    }
                Main.equipDisplay.Add(newDisplay);
            }

        }

        [HarmonyPatch("UnEquip")]
        [HarmonyPostfix]
        static void UnEquip()
        {
            for (int i = Main.equipDisplay.Count - 1; i >= 0; i--)
                if (Main.equipDisplay[i].parentSlot.itemInstance == null || Main.equipDisplay[i].parentSlot.itemInstance.BaseItemMaxUses <= 1)
                {
                    Main.equipDisplay[i].Destroy();
                    Main.equipDisplay.RemoveAt(i);
                }
        }
    }

    [HarmonyPatch(typeof(MonoBehaviour_ID), "OnDestroy")]
    static class Patch_CreatureDestroy
    {
        static void Prefix(MonoBehaviour_ID __instance)
        {
            if (__instance is Network_Entity)
            {
                int ind = Main.ents.IndexOf(__instance as Network_Entity);
                if (ind >= 0)
                {
                    Main.bars.RemoveAt(ind);
                    Main.ents.RemoveAt(ind);
                }
            }
        }
    }

    [HarmonyPatch(typeof(Network_Entity))]
    public class Patch_NetworkEntity
    {
        [HarmonyPatch("Start")]
        [HarmonyPostfix]
        public static void Start(Network_Entity __instance)
        {
            if (Traverse.Create(__instance as PlayerStats).Field("playerNetwork").GetValue<Network_Player>()?.IsLocalPlayer ?? false)
                return;
            new HealthBar(__instance);
        }

        [HarmonyPatch("Update")]
        [HarmonyPostfix]
        static void Update(Network_Entity __instance)
        {
            int ind = Main.ents.IndexOf(__instance);
            if (ind > -1)
                Main.bars[ind].Update();
        }

        [HarmonyPatch("Damage")]
        [HarmonyPostfix]
        static void Damage(Network_Entity __instance, float damage, Vector3 hitPoint)
        {
            if (RAPI.GetLocalPlayer().gameObject == __instance.gameObject)
            {
                Main.SetDamage(damage);
                return;
            }
            new damageIndicator(__instance.transform, damage, hitPoint);
        }
    }

    [HarmonyPatch(typeof(ItemInstance_Inventory))]
    static class Patch_ItemInstanceInventory
    {
        [HarmonyPatch("Description", MethodType.Getter)]
        [HarmonyPostfix]
        static void Description(ItemInstance_Inventory __instance, ref string __result)
        {
            List<Item_Base> items = ItemManager.GetAllItems();
            foreach (Item_Base item in items)
                if (item.settings_Inventory == __instance)
                {
                    MeleeWeapon weapon = null;
                    foreach (ItemConnection connect in RAPI.GetLocalPlayer().PlayerItemManager.useItemController.allConnections)
                        if (connect.inventoryItem == item)
                        {
                            weapon = connect.obj.GetComponent<MeleeWeapon>();
                            break;
                        }
                    string str = "";
                    if (item.settings_consumeable != null)
                        str += item.GetFoodValues();
                    if ((item.settings_buildable?.HasBuildablePrefabs ?? false) && item.settings_buildable.GetBlockPrefab(0)?.GetComponent<CookingTable_Recipe_UI>())
                        str += item.settings_buildable.GetBlockPrefab(0).GetComponent<CookingTable_Recipe_UI>().Recipe.Result.GetFoodValues();
                    if (weapon != null)
                        str += weapon != null ? "\nDamage: " + Traverse.Create(weapon).Field("damage").GetValue<int>().ToString() : "";
                    if (str.Length != 0)
                        __result += "\n" + str;
                    break;
                }
        }

        [HarmonyPatch("DisplayName", MethodType.Getter)]
        [HarmonyPostfix]
        static void DisplayName(ItemInstance_Inventory __instance, ref string __result)
        {
            if (!Main.showItemIds)
                return;
            List<Item_Base> items = ItemManager.GetAllItems();
            foreach (Item_Base item in items)
                if (item.settings_Inventory == __instance)
                {
                    __result += " (" + item.UniqueName + "#" + item.UniqueIndex + ")";
                    break;
                }
        }
    }

    [HarmonyPatch(typeof(AI_State_Attack_Block_Shark))]
    static class Patch_SharkAttackRaft
    {
        [HarmonyPatch("InitiateAttackOnBlock")]
        [HarmonyPostfix]
        static void InitiateAttackOnBlock(Block p_targetBlock)
        {
            Main.sharkI.StartAttack(p_targetBlock.transform);
        }

        [HarmonyPatch("ExitState")]
        [HarmonyPostfix]
        static void ExitState()
        {
            Main.sharkI.StopAttack();
        }

        [HarmonyPatch("CheckBlockDiveAwayFromBlock")]
        [HarmonyPostfix]
        static void CheckBlockDiveAwayFromBlock(bool __result)
        {
            if (__result)
                Main.sharkI.StopAttack();
        }
    }

    [HarmonyPatch(typeof(Network_Host_Entities), "CreateShark")]
    static class Patch_SharkRespawnStart
    {
        static void Prefix(float timeDelay)
        {
            Main.sharkTime.Add(timeDelay);
        }
    }

    [HarmonyPatch(typeof(Inventory))]
    static class Patch_Inventory
    {
        [HarmonyPatch("Start")]
        [HarmonyPostfix]
        public static void Start(Inventory __instance)
        {
            duraText newObj = __instance.gameObject.AddComponent<duraText>();
            newObj.container = Main.CreateText(__instance.gameObject.transform, 0, 0, "hi", Main.canvas.dropText.fontSize, Main.canvas.dropText.color, 0.2f * Screen.height, 50, Main.canvas.dropText.font, "duraText");
            newObj.textComponent = newObj.container.GetComponent<Text>();
            Main.CopyTextShadow(newObj.container, Main.canvas.dropText.gameObject);
            newObj.textComponent.gameObject.SetActive(false);
        }

        [HarmonyPatch("HoverEnter")]
        [HarmonyPostfix]
        static void HoverEnter(Inventory __instance, Slot slot)
        {
            if (!slot.IsEmpty && slot.itemInstance.BaseItemMaxUses > 1)
            {
                duraText obj = __instance.gameObject.GetComponent<duraText>();
                if (obj != null)
                {
                    obj.textComponent.gameObject.SetActive(true);
                    obj.textComponent.text = slot.itemInstance.Uses.ToString() + "/" + slot.itemInstance.BaseItemMaxUses.ToString();
                }
            }
        }

        [HarmonyPatch("HoverExit")]
        [HarmonyPostfix]
        static void HoverExit(Inventory __instance)
        {
            duraText obj = __instance.gameObject.GetComponent<duraText>();
            if (obj != null && Main.showDurability)
            {
                obj.textComponent.gameObject.SetActive(false);
            }
        }

        [HarmonyPatch("Update")]
        [HarmonyPostfix]
        static void Update(Inventory __instance)
        {
            duraText obj = __instance.gameObject.GetComponent<duraText>();
            if (obj != null)
            {
                obj.textComponent.transform.position = Input.mousePosition;
                obj.textComponent.rectTransform.localPosition += new Vector3(0.12f * Screen.height, 0);
                obj.textComponent.rectTransform.sizeDelta = new Vector2(0.2f * Screen.height, 50);
            }
        }
    }


    public class UILine : Image
    {
        Vector2 _p;
        Vector2 _s;
        float _a;
        static Vector2 _cP;
        static Vector2 _cS;
        static float _cA;
        public Vector2 start
        {
            get => _p;
            set
            {
                _p = value;
                UpdatePosition();
            }
        }
        public float length
        {
            get => _s.x;
            set
            {
                _s.x = value;
                UpdatePosition();
            }
        }
        public float angle
        {
            get => _a;
            set
            {
                _a = value;
                UpdatePosition();
            }
        }
        public float width
        {
            get => _s.y;
            set
            {
                _s.y = value;
                UpdatePosition();
            }
        }
        UILine()
        {
            _p = _cP;
            _s = _cS;
            _a = _cA;
        }
        protected override void Start()
        {
            base.Start();
            UpdatePosition();
        }
        void UpdatePosition()
        {
            rectTransform.localRotation = Quaternion.Euler(0, 0, _a);
            rectTransform.pivot = new Vector2(_s.y / 2f / _s.x, 0.5f);
            rectTransform.localPosition = _p;
            rectTransform.sizeDelta = _s;
        }
        public static void setCreationValues(Vector2 start, float lineLength, float lineWidth, float lineAngle)
        {
            _cP = start;
            _cS = new Vector2(lineLength, lineWidth);
            _cA = lineAngle;
        }
    }

    public class HealthBar
    {
        Canvas canvas;
        UILine green;
        Text numDisplay;
        float barlength;
        Network_Entity parent;
        GameObject container;
        public float health;
        public float maxHealth;

        public HealthBar(Network_Entity creature)
        {
            parent = creature;
            container = new GameObject();
            container.transform.SetParent(parent.transform, false);
            container.transform.localPosition = new Vector3(0, 2, 0);
            var rect = container.AddComponent<RectTransform>();
            rect.sizeDelta = new Vector2(1, 1f);
            canvas = container.AddComponent<Canvas>();
            canvas.transform.SetParent(container.transform, false);
            container.layer = 21;
            canvas.transform.localScale = new Vector3(0.001f, 0.001f, 0.001f);
            var trans = canvas.GetComponent<RectTransform>();
            trans.sizeDelta = new Vector2(1, 1f);
            barlength = 300;
            var lineWidth = 50f;
            var textWidth = 300f;
            var borderSize = 10f;
            Main.CreateLine(canvas, barlength + borderSize * 2, lineWidth + borderSize * 2, lineWidth / 2 - barlength / 2, 0, Color.grey, 0).GetComponent<UILine>();
            Main.CreateLine(canvas, barlength, lineWidth, lineWidth / 2 - barlength / 2, 0, new Color(0.8f, 0, 0), 0).GetComponent<UILine>();
            green = Main.CreateLine(canvas, 0, lineWidth, lineWidth / 2 - barlength / 2, 0, Color.green, 0).GetComponent<UILine>();
            numDisplay = Main.CreateText(container.transform, (barlength / 2 + textWidth / 2 + borderSize + 15), -15, "??? / ???", (int)lineWidth, Main.canvas.dropText.color, textWidth, lineWidth * 2, Main.canvas.dropText.font).GetComponent<Text>();
            Main.CopyTextShadow(numDisplay.gameObject, Main.canvas.dropText.gameObject);
            health = parent.stat_health.Value;
            maxHealth = parent.stat_health.Max;
            Main.bars.Add(this);
            Main.ents.Add(parent);
            var shad = container.AddComponent<Shadow>();
            shad.effectColor = Color.black;
            shad.effectDistance = Vector2.zero;
            shad.useGraphicAlpha = false;
        }

        public void Update()
        {
            health = parent.stat_health.Value;
            maxHealth = parent.stat_health.Max;
            green.length = barlength * health / maxHealth;
            numDisplay.text = ((int)health).ToString() + " / " + ((int)maxHealth).ToString();
        }

        public void UpdateFacing()
        {
            var dirVec = Helper.MainCamera.transform.position - canvas.transform.position;
            var angle = Mathf.Acos(dirVec.z / dirVec.XZOnly().magnitude) / (float)Math.PI * 180f + 180;
            container.transform.rotation = Quaternion.Euler(0, dirVec.x < 0 ? -angle : angle, 0);
            container.SetActive(dirVec.magnitude < Main.barDrawDistance && !Main.hasExclusion(CleanName(parent.name).ToLower()) && (Main.showFullBars || health < maxHealth));
        }

        public string CleanName(string entityName)
        {
            if (entityName.EndsWith("(Clone)"))
                entityName = entityName.Substring(0, entityName.Length - 7);
            if (entityName.StartsWith("AI_"))
                entityName = entityName.Remove(0, 3);
            return entityName;
        }

        public void Destroy() => Object.Destroy(container);
    }

    public class TimeBar
    {
        GameObject container;
        Canvas canvas;
        UILine colored;
        UILine fading;
        float barlength;
        static Color night = new Color(0, 0, 0.4f);
        static Color day = new Color(0.3f, 0.6f, 1);
        static float sunrise = 4;
        static float sunset = 20;

        public TimeBar(GameObject parent, int fontSize, float X, float Y)
        {
            container = new GameObject();
            container.transform.SetParent(parent.transform, false);
            var transObj = container.AddComponent<RectTransform>();
            transObj.sizeDelta = parent.GetComponent<RectTransform>().sizeDelta;
            canvas = container.AddComponent<Canvas>();
            canvas.transform.SetParent(container.transform, false);
            var trans = canvas.GetComponent<RectTransform>();
            barlength = fontSize * 3;
            var lineWidth = fontSize;
            var border = 3f;
            var barX = lineWidth / 2 - trans.sizeDelta.x / 2 + border + X;
            var barY = lineWidth / 2 + trans.sizeDelta.y / 2 + border - Y;
            Main.CreateLine(canvas, barlength + border * 2, lineWidth + border * 2, barX, barY, Color.grey, 0).GetComponent<UILine>();
            colored = Main.CreateLine(canvas, barlength, lineWidth, barX, barY, Color.black, 0).GetComponent<UILine>();
            fading = Main.CreateLine(canvas, barlength / 2, lineWidth, barX, barY, Color.yellow, 0).GetComponent<UILine>();
        }

        public void Update(float TimeOfDay)
        {
            SetActive(!Main.timeIsClock && Main.clockSetting != 0);
            if (TimeOfDay >= sunrise && TimeOfDay < sunset)
            {
                TimeOfDay -= sunrise;
                colored.color = day;
                fading.color = night;
                fading.length = barlength * TimeOfDay / (sunset - sunrise);
            }
            else
            {
                TimeOfDay -= sunset;
                if (TimeOfDay < 0)
                    TimeOfDay += 24;
                colored.color = night;
                fading.color = day;
                fading.length = barlength * TimeOfDay / (24 - sunset + sunrise);
            }
        }

        public void SetActive(bool active) => container.SetActive(active);
    }

    public class Compass
    {
        GameObject container;
        GameObject pointer;
        public Compass(GameObject parent, int fontSize, float X, float Y)
        {
            try
            {
                container = Main.CreateText(parent.transform, X, -Y, "●", fontSize * 10, Color.black, 500, fontSize * 15, Main.canvas.dropText.font);

                pointer = Main.CreateText(container.transform, 0, 0, "<color=#4444FF><</color>◎<color=#FF0000>></color>", fontSize * 3, Color.green, 500, fontSize * 4.5f, Main.canvas.dropText.font);
                var text = container.GetComponent<Text>();
                text.rectTransform.anchorMin = new Vector2(0, 1);
                text.rectTransform.anchorMax = new Vector2(0, 1);
                text.rectTransform.offsetMin = new Vector2(X, -Y);
                var text2 = pointer.GetComponent<Text>();
                text2.rectTransform.anchorMin = new Vector2(0.5f, 0.45f);
                text2.rectTransform.anchorMax = new Vector2(0.5f, 0.45f);
                text2.rectTransform.offsetMin = new Vector2(-text2.preferredWidth, -text2.preferredHeight) / 2 - Vector2.one;
                text2.rectTransform.offsetMax = new Vector2(text2.preferredWidth, text2.preferredHeight) / 2 - Vector2.one;
                text2.rectTransform.pivot = new Vector2(0.51f, 0.51f);// + Vector2.one;
                text2.supportRichText = true;
            }
            catch (Exception e) { Debug.LogError(e); }
        }

        public void Update()
        {
            SetActive(Main.showCompass);
            if (RAPI.GetLocalPlayer() != null)
                pointer.transform.rotation = Quaternion.Euler(0, 0, RAPI.GetLocalPlayer().transform.rotation.eulerAngles.y + 90);
            var text = container.GetComponent<Text>();
            text.rectTransform.offsetMax = new Vector2(text.rectTransform.offsetMin.x + text.preferredWidth, text.rectTransform.offsetMin.y + text.preferredHeight);
        }

        public void SetActive(bool active) => container.SetActive(active);
    }

    public class damageIndicator
    {
        GameObject container;
        Vector3 startPos;
        Vector3 angle;
        float timePassed;
        Text numDisplay;
        public damageIndicator(Transform init, float amount, Vector3 hitPos)
        {
            amount = -amount;
            container = new GameObject();
            container.transform.SetParent(init, false);
            container.transform.parent = null;
            startPos = container.transform.position;
            startPos.y += 1;
            RectTransform rect = container.AddComponent<RectTransform>();
            rect.sizeDelta = new Vector2(1, 1f);
            float scaler = 100;
            var canvas = container.AddComponent<Canvas>();
            container.layer = 21;
            canvas.transform.SetParent(container.transform, false);
            canvas.transform.localScale = new Vector3(0.1f, 0.1f, 0.1f) / scaler;
            var trans = canvas.GetComponent<RectTransform>();
            trans.sizeDelta = new Vector2(1, 1f);
            var obj = Main.CreateText(container.transform, 0, 0, damageString(amount), (int)(2 * scaler), amount >= 0 ? Color.green : Color.red, 5 * scaler, 5 * scaler, Main.canvas.dropText.font);
            Main.CopyTextShadow(obj, Main.canvas.dropText.gameObject);
            numDisplay = obj.GetComponent<Text>();
            var a = new System.Random().NextDouble() * 2 * Math.PI;
            angle = new Vector3((float)Math.Cos(a), 0, (float)Math.Sin(a));
            Main.pops.Add(this);
        }
        public void Update()
        {
            timePassed += Time.deltaTime * 1.5f;
            var newPos = startPos + angle * timePassed;
            newPos.y += (float)(Math.Pow(1, 2) - Math.Pow(timePassed - 1, 2)) / 2;
            container.transform.position = newPos;
            var dirVec = Helper.MainCamera.transform.position - container.transform.position;
            var a = Mathf.Acos(dirVec.z / dirVec.XZOnly().magnitude) / (float)Math.PI * 180f + 180;
            container.transform.rotation = Quaternion.Euler(0, dirVec.x < 0 ? -a : a, 0);
            numDisplay.color = new Color(numDisplay.color.r, numDisplay.color.g, numDisplay.color.b, 1 - timePassed / 3);
            if (numDisplay.color.a <= 0)
                Destroy();
        }
        string damageString(float amount) => (amount > 0 ? "+" : "") + ((int)amount).ToString();
        public void Destroy()
        {
            Main.pops.Remove(this);
            Object.Destroy(container);
        }
    }

    public class sharkIndicator
    {
        Transform position;
        float timePassed;
        GameObject container;
        Text alert;
        bool attacking;
        public sharkIndicator()
        {
            timePassed = 0;
            var rect = Main.canvas.GetComponent<RectTransform>();
            container = Main.CreateText(Main.canvas.transform, rect.sizeDelta.x * rect.localScale.x * 0.45f, rect.sizeDelta.y * rect.localScale.y * 0.45f, "alert", Main.canvas.dropText.fontSize * 2, Color.red, rect.sizeDelta.x * rect.localScale.x * 0.06f, Main.canvas.dropText.fontSize * 3, Main.canvas.dropText.font);
            Main.CopyTextShadow(container, Main.canvas.dropText.gameObject);
            alert = container.GetComponent<Text>();
            alert.transform.SetAsFirstSibling();
            attacking = false;
            container.SetActive(false);
        }
        public void StartAttack(Transform loc)
        {
            position = loc;
            attacking = true;
            timePassed = 0;
        }
        public void StopAttack()
        {
            attacking = false;
        }
        public void Update()
        {
            timePassed += Time.deltaTime;
            if (container.activeSelf != (attacking && position && CanvasHelper.ActiveMenu != MenuType.Inventory && alert.transform.position.z > 0))
                container.SetActive(!container.activeSelf);
            if (position)
            {
                alert.transform.position = Helper.MainCamera.WorldToScreenPoint(position.position);
                alert.color = new Color(1, 0, 0, (float)Math.Sin(timePassed * 5) / 4 + 0.75f);
            }
        }
        public void Destroy() => Object.Destroy(container);
    }

    public class centerPointer
    {
        Transform position => ComponentManager<Raft>.Value?.transform;
        float timePassed;
        GameObject container;
        Text text;
        public centerPointer()
        {
            timePassed = 0;
            container = Main.CreateText(Main.canvas.transform, 0, 0, "◈", Main.canvas.dropText.fontSize * 2, Color.green, Main.canvas.dropText.fontSize * 3, Main.canvas.dropText.fontSize * 3, Main.canvas.dropText.font, "CenterText");
            Main.CopyTextShadow(container, Main.canvas.dropText.gameObject);
            text = container.GetComponent<Text>();
            text.transform.SetAsFirstSibling();
            text.rectTransform.sizeDelta = new Vector2(text.preferredWidth, text.preferredHeight);
            container.SetActive(false);

        }
        public void SetActive(bool visible) => container.SetActive(visible);
        public void Update()
        {
            timePassed += Time.deltaTime;
            if (position && Helper.MainCamera)
            {
                text.transform.position = Helper.MainCamera.WorldToScreenPoint(position.position);
                SetActive(Main.showCenter && CanvasHelper.ActiveMenu != MenuType.Inventory && text.transform.position.z > 0);
                if (container.activeInHierarchy)
                {
                    text.rectTransform.sizeDelta = new Vector2(text.preferredWidth, text.preferredHeight);
                    text.color = new Color(0, 1, 0, (float)Math.Sin(timePassed * 5) / 4 + 0.75f);
                }
            }
        }
        public void Destroy() => Object.Destroy(container);
    }

    public class duraText : MonoBehaviour
    {
        public GameObject container;
        public Text textComponent;
    }

    public class HUDEquipmentDisplay
    {
        public CanvasHelper canvas;
        public Slot displaySlot;
        public GameObject gameObject;
        public Slot parentSlot;
        public RectTransform rectTransform;
        Vector2 basePosition;
        Vector2 offset;
        public int slotIndex;
        public HUDEquipmentDisplay(CanvasHelper helper, Slot parentSlot, GameObject prefab, Vector2 basePosition, int slotIndex, Vector2 displaySize)
        {
            canvas = helper;
            this.parentSlot = parentSlot;
            gameObject = UnityEngine.Object.Instantiate(prefab, canvas.gameObject.transform);
            displaySlot = gameObject.GetComponent<Slot>();
            rectTransform = gameObject.GetComponent<RectTransform>();
            gameObject.transform.localScale = prefab.transform.localScale;
            rectTransform.localPosition = new Vector2(0, 0);
            rectTransform.sizeDelta = displaySize;
            offset = new Vector2(0, rectTransform.sizeDelta.y * 1.2f);
            this.basePosition = basePosition;
            this.slotIndex = slotIndex;
        }

        public void Update(int index)
        {
            gameObject.SetActiveSafe(CanvasHelper.ActiveMenu == MenuType.None && Main.showHUDEquipment);
            if (!gameObject.activeSelf)
                return;
            if (parentSlot.itemInstance != null)
                displaySlot.SetItem(parentSlot.itemInstance.Clone());
            var screenSize = Main.canvas.GetComponent<RectTransform>().sizeDelta;
            rectTransform.localPosition = new Vector2((basePosition.x + offset.x * index) * Main.aspectRatio - screenSize.x / 2, basePosition.y + offset.y * index - screenSize.y / 2 + rectTransform.sizeDelta.y);
        }

        public void Destroy()
        {
            Object.Destroy(gameObject);
            Object.Destroy(displaySlot.gameObject);
        }
    }

    class StatManager
    {
        string messagePrefix;
        Func<bool, bool> modify;
        string nT;
        string aT;
        string nF;
        string aF;
        public StatManager(string prefix, Func<bool, bool> editor, string nowTrue = "now visible", string alreadyTrue = "already visible", string nowFalse = "now hidden", string alreadyFalse = "already hidden")
        {
            messagePrefix = prefix;
            modify = editor;
            nT = nowTrue;
            aT = alreadyTrue;
            nF = nowFalse;
            aF = alreadyFalse;
        }
        public string Set(bool value)
        {
            return messagePrefix + (value ? (modify(true) ? nT : aT) : (modify(false) ? nF : aF));
        }
    }
}